<div class="content" [class.content]="!dialogRef">
  <div class="dialog-title-wrapper">
    <h3 class="dialog-title">Edit a Group</h3>

    <button
      *ngIf="dialogRef"
      mat-icon-button
      class="close-dialog-button"
      (click)="dialogRef.close(undefined)"
      tabindex="-1"
    >
      <mat-icon>close</mat-icon>
    </button>
  </div>

  <div [class.detail-block]="!dialogRef">
    <mat-horizontal-stepper [linear]="true" #stepper (selectionChange)="stepInteraction($event)">
      <mat-step label="Naming" [completed]="validateNaming()">
        <p class="metadata-nested">
          To easily identify your group later, it should have a recognizable name.
        </p>

        <ng-container *ngIf="!group.creator || group.creator._id === ''">
          <div class="metadata-nested">
            It seems like you are not logged in. Only registered and logged in Semantic Kompakkt users can
            create groups. If this is a mistake, try logging out and back in.
          </div>
        </ng-container>

        <ng-container *ngIf="group.creator">
          <div class="metadata-nested">
            <mat-form-field>
              <input placeholder="Group name" required matInput [(ngModel)]="group.name" />
            </mat-form-field>
          </div>
        </ng-container>

        <div class="button-row">
          <button mat-flat-button color="primary" matStepperNext [disabled]="!validateNaming()">
            Next
          </button>
        </div>
      </mat-step>
      <mat-step
        label="Select members"
        #stepPeople
        [completed]="validatePersons() && stepPeople.interacted"
      >
        <div class="metadata-nested">
          <mat-form-field>
            <input
              #personInput
              placeholder="Search for a person to add"
              name="search-person"
              matInput
              (input)="changeSearchInput($event)"
              [(ngModel)]="searchPersonText"
              [matAutocomplete]="personAutocomplete"
            />
          </mat-form-field>

          <mat-autocomplete
            #personAutocomplete="matAutocomplete"
            (optionSelected)="selectAutocompletePerson(personInput, $event)"
          >
            <mat-option *ngFor="let person of autocompletePersons" [value]="person">{{
              person.fullname
            }}</mat-option>
          </mat-autocomplete>
        </div>

        <div class="person-drag-drop">
          <div class="metadata-nested">
            <h3>Persons</h3>
            <p class="note">
              Regular group members receive annotation access for objects/collections associated
              with the group
            </p>
            <div
              cdkDropList
              #personList="cdkDropList"
              [cdkDropListData]="group.members"
              [cdkDropListConnectedTo]="[ownerList]"
              (cdkDropListDropped)="drop($event)"
            >
              <div cdkDrag *ngFor="let member of group.members" class="drag-drop">
                <button mat-button (click)="removePerson(member._id)">
                  <mat-icon>remove_circle_outline</mat-icon>
                </button>
                <span class="itemname">{{ member.fullname }}</span>
              </div>
            </div>
          </div>
          <div class="metadata-nested">
            <h3>Group owners</h3>
            <p class="note">
              Group owners receive annotation access <i>and</i> can edit group members
            </p>
            <div
              cdkDropList
              #ownerList="cdkDropList"
              [cdkDropListData]="group.owners"
              [cdkDropListConnectedTo]="[personList]"
              (cdkDropListDropped)="drop($event)"
            >
              <mat-card cdkDrag *ngFor="let owner of group.owners" class="drag-drop">
                <button mat-button (click)="removePerson(owner._id)">
                  <mat-icon>remove_circle_outline</mat-icon>
                </button>
                <span class="itemname">{{ owner.fullname }}</span>
              </mat-card>
            </div>
          </div>
        </div>

        <h3 *ngIf="group.members.length === 0 && group.owners.length === 0">
          You need to add at least one person to the group before you can proceed.
        </h3>

        <div class="button-row">
          <button mat-flat-button matStepperPrevious>Previous</button>
          <button mat-flat-button color="primary" matStepperNext [disabled]="!validatePersons()">
            Next
          </button>
        </div>
      </mat-step>
      <mat-step label="Finish" #stepFinish [completed]="isSubmitted && stepFinish.interacted">
        <p class="metadata-nested">
          Please take a look at your group and check if everything is in order before submitting
        </p>

        <div class="metadata-nested">
          <h3>Group name: {{ group.name }}</h3>

          <div *ngIf="group.creator">
            <h3>Group creator: {{ group.creator.fullname }}</h3>
          </div>
        </div>

        <div class="metadata-nested">
          <div *ngIf="group.members.length === 0">
            <h3>This group has <b>no</b> regular members, only owners</h3>
          </div>
          <div *ngIf="group.members.length > 0">
            <h3>Members</h3>
            <mat-chip-list>
              <mat-chip *ngFor="let member of group.members">{{ member.fullname }}</mat-chip>
            </mat-chip-list>
          </div>
        </div>

        <div class="metadata-nested">
          <div *ngIf="group.owners.length === 0">
            <h3>This group has no owners apart from <b>yourself</b></h3>
          </div>
          <div *ngIf="group.owners.length > 0">
            <h3>Owners</h3>
            <mat-chip-list>
              <mat-chip *ngFor="let owner of group.owners">{{ owner.fullname }}</mat-chip>
            </mat-chip-list>
          </div>
        </div>

        <div class="button-row">
          <button
            mat-raised-button
            color="primary"
            [disabled]="isSubmitting || isSubmitted"
            (click)="tryFinish(stepper, stepFinish)"
          >
            Submit
          </button>
        </div>
      </mat-step>
      <mat-step label="Success" #stepSuccess>
        <h3>The group has been submitted and saved!</h3>
        <h3>Feel free to leave this page</h3>
      </mat-step>
    </mat-horizontal-stepper>
  </div>
</div>
